
subroutine CalcSingleAtomEnergy(Pos, L,MoveAtom, rc, PEnergy,Dim, NAtom)
    implicit none
    integer, intent(in) ::  Dim, NAtom, MoveAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), parameter ::  r0 = 1.
	integer:: j
    real(8) :: d2,id2,rc2,id6,id12,Shift,d,z,PEup,PEdown,idd3,iddd3
	real(8),dimension (Dim)::Posi,rij,Fij
    !======== YOUR CODE HERE ========
	PEnergy=0.
	Shift=-4.*(rc**(-12)-rc**(-6))
	rc2=rc*rc
	Posi=Pos(MoveAtom,:) 
	    do j=0, NAtom-1
		   if (j==MoveAtom) then
                PEnergy=PEnergy+0.
		   else 
		        rij=Pos(j,:)-Posi
                rij(1)=rij(1)-L*dnint(rij(1)/L)
				rij(2)=rij(2)-L*dnint(rij(2)/L)
		        d2=sum(rij*rij)
				if (d2<=rc2) then
				    id2=1./d2
					id6=id2*id2*id2
					id12=id6*id6
                    PEnergy=PEnergy+4.*(id12-id6)+Shift	
				else
				    cycle 
		        end if 
		   end if
		   z=Posi(3)
		   idd3=(L/2.-z)**(-3)
		   iddd3=(L/2.+z)**(-3)		   
		   PEup=2.*(2./15.*idd3*idd3*idd3-idd3)
		   PEdown=2.*(2./15.*iddd3*iddd3*iddd3-iddd3)
		   PEnergy=PEnergy+PEup+PEdown
		end do
end subroutine


subroutine CalcEnergy(Pos, L, rc, PEnergy,Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), parameter ::  r0 = 1.
	integer:: i,j
    real(8) :: d2,id2,rc2,id6,id12,Shift,d,z, PEup,PEdown,idd3,iddd3
	real(8),dimension (Dim)::Posi,rij,Fij
    !======== YOUR CODE HERE ========
	PEnergy=0.
	Shift=-4.*(rc**(-12)-rc**(-6))
	rc2=rc*rc
	do i = 0, NAtom-1
	    Posi=Pos(i,:)  
	    do j=i+1, NAtom-1
		   rij=Pos(j,:)-Posi
           rij(1)=rij(1)-L*dnint(rij(1)/L)
		   rij(2)=rij(2)-L*dnint(rij(2)/L)
		   d2=sum(rij*rij)
		   d=sqrt(d2) 
		   if (d2<=rc2) then
		         id2=1./d2
				 id6=id2*id2*id2
				 id12=id6*id6
                 PEnergy=PEnergy+4.*(id12-id6)+Shift
		   else
                cycle  
		   end if
		end do
		   z=Posi(3)
		   idd3=(L/2.-z)**(-3)
		   iddd3=(L/2.+z)**(-3)		   
		   PEup=2.*(2./15.*idd3*idd3*idd3-idd3)
		   PEdown=2.*(2./15.*iddd3*iddd3*iddd3-iddd3)
		   PEnergy=PEnergy+PEup+PEdown
	end do
end subroutine

